<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class RegB356 extends Record {
    /**
     * @var array Lista de colunas esperadas para o bloco
     */   
    protected $templateColumns = [
       
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "agency",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "bank",
            'position' => 9,
            'size' => 20,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "account",
            'position' => 29,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "ch_start",
            'position' => 37,
            'size' => 6,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "ch_final",
            'position' => 43,
            'size' => 6,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "reason_susta",
            'position' => 49,
            'size' => 10,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "report",
            'position' => 59,
            'size' => 13,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "source",
            'position' => 72,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

        [
            'name' => "message",
            'position' => 76,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "document",
            'position' => 77,
            'size' => 14,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],

        [
            'name' => "filler_1",
            'position' => 91,
            'size' => 25,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

    ];


    public function __construct($values = null) {
        $this->createColumns();
    }


}
