<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks;

use Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX\SubTypeN440_00;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX\SubTypeN440_01;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX\SubTypeN440_02;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX\SubTypeN440_03;
use Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX\SubTypeN440_99;
use Schaffen\SerasaRemessa\Utils\Record;

class RegN440 extends Record {
    protected $values;
    
    protected $blockCodeSubType;

    public $subtypeInstance;

    public function __construct($values = null, $blockCodeSubType = null) {
        $this->values = $values;
        $this->blockCodeSubType = $blockCodeSubType;

        switch ($blockCodeSubType) {
            case '00':
                $this->subtypeInstance = new SubTypeN440_00($values);
                break;
            case '01':
                $this->subtypeInstance = new SubTypeN440_01($values);
                break;
            case '02':
                $this->subtypeInstance = new SubTypeN440_02($values);
                break;
            case '03':
                $this->subtypeInstance = new SubTypeN440_03($values);
                break;
            case '99':
                $this->subtypeInstance = new SubTypeN440_99($values);
                break;
            default:
                $this->subtypeInstance = new SubTypeN440_00($values);
                break;
        }
    }

    public function getValues() {
        return $this->subtypeInstance->getValues();
    }
}