<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeNREA_5 extends Record {
    public $name = "riskscoring_value_calc";
    
    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_feat",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "subtipo",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "dt_inf",
            'position' => 11,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "ddd",
            'position' => 19,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "tel",
            'position' => 23,
            'size' => 10,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "ident",
            'position' => 33,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 34,
            'size' => 82,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_feat'] = substr($values, 4, 4);
        $newValues['subtipo'] = substr($values, 8, 2);
        $newValues['dt_inf'] = substr($values, 10, 8);
        $newValues['ddd'] = substr($values, 18, 4);
        $newValues['tel'] = substr($values, 22, 10);
        $newValues['ident'] = substr($values, 32, 1);
        $newValues['filler'] = substr($values, 33, 82);
        
        $this->setColumnsValues($newValues);
    }
}