<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypesQSCN_5_SubBlock_1 extends Record {
    public $name = "spc";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "bloco",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "subbloco",
            'position' => 11,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "logradouro",
            'position' => 12,
            'size' => 70,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "bairro",
            'position' => 82,
            'size' => 20,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 102,
            'size' => 14,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['bloco'] = substr($values, 8, 2);
        $newValues['subbloco'] = substr($values, 10, 1);
        $newValues['logradouro'] = substr($values, 11, 70);
        $newValues['bairro'] = substr($values, 81, 20);
        $newValues['filler'] = substr($values, 101, 14);
        
        $this->setColumnsValues($newValues);
    }
}