<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypesQSCN_6 extends Record {
    public $name = "spc";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "code_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "bloco",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "tp_anotacao",
            'position' => 11,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "desc_anot",
            'position' => 14,
            'size' => 27,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "qtde_ocor",
            'position' => 41,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "dt_ult_ocor",
            'position' => 50,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "vlr_total",
            'position' => 58,
            'size' => 13,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 71,
            'size' => 45,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['code_cons'] = substr($values, 4, 4);
        $newValues['bloco'] = substr($values, 8, 2);
        $newValues['tp_anotacao'] = substr($values, 10, 3);
        $newValues['desc_anot'] = substr($values, 13, 27);
        $newValues['qtde_ocor'] = substr($values, 40, 9);
        $newValues['dt_ult_ocor'] = substr($values, 49, 8);
        $newValues['vlr_total'] = substr($values, 57, 13);
        $newValues['filler'] = substr($values, 70, 45);
        
        $this->setColumnsValues($newValues);
    }
}