<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypesQSCN_7 extends Record {
    public $name = "spc";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "bloco",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "tipo_anota",
            'position' => 11,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "desc_anota",
            'position' => 14,
            'size' => 27,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "msg",
            'position' => 41,
            'size' => 70,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 111,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['bloco'] = substr($values, 8, 2);
        $newValues['tipo_anota'] = substr($values, 10, 3);
        $newValues['desc_anota'] = substr($values, 13, 27);
        $newValues['msg'] = substr($values, 40, 70);
        $newValues['filler'] = substr($values, 110, 5);
        
        $this->setValues($newValues);
    }
}