<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeRECA_99 extends Record {
    public $name = "riskscoring_msg_without_calc";
    
    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "code_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_tip",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "dtref",
            'position' => 11,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod",
            'position' => 19,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "naocalc",
            'position' => 24,
            'size' => 80,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 104,
            'size' => 12,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],

    ];

    public function __construct($values = null) {
        $this->createColumns();

        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['code_cons'] = substr($values, 4, 4);
        $newValues['sub_tip'] = substr($values, 8, 2);
        $newValues['dtref'] = substr($values, 10, 8);
        $newValues['cod'] = substr($values, 18, 5);
        $newValues['naocalc'] = substr($values, 23, 80);
        $newValues['filler'] = substr($values, 103, 12);
        
        $this->setColumnsValues($newValues);
    }
}