<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypesSSCN_RF_3 extends Record {
    public $name = "spc";

    public $templateColumns = [   
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "inf",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "bloco",
            'position' => 11,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "tipo_cnae",
            'position' => 13,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "qtde_cnae_sec",
            'position' => 14,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sigla_cnae",
            'position' => 17,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "descricao_cnae",
            'position' => 24,
            'size' => 70,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "expansao",
            'position' => 94,
            'size' => 22,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['inf'] = substr($values, 8, 2);
        $newValues['bloco'] = substr($values, 10, 2);
        $newValues['tipo_cnae'] = substr($values, 12, 1);
        $newValues['qtde_cnae_sec'] = substr($values, 13, 3);
        $newValues['sigla_cnae'] = substr($values, 16, 5);
        $newValues['descricao_cnae'] = substr($values, 23, 70);
        $newValues['expansao'] = substr($values, 93, 22);
        
        $this->setColumnsValues($newValues);
    }

}